//+------------------------------------------------------------------+
//|                                                     Fractals.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Magenta

#property indicator_color4 Black
//---- input parameters
extern int PipBuffer=2;
//---- buffers
double ExtUpFractalsBuffer[];
double ExtDownFractalsBuffer[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double HighLevel;
double LowLevel;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping  
    SetIndexBuffer(0,ExtUpFractalsBuffer);
    SetIndexBuffer(1,ExtDownFractalsBuffer); 
    SetIndexBuffer(2,ExtMapBuffer1);
    SetIndexBuffer(3,ExtMapBuffer2);    
//---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,119);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,119);
    SetIndexStyle(2,DRAW_ARROW);
    SetIndexArrow(2,233);
    SetIndexStyle(3,DRAW_ARROW);
    SetIndexArrow(3,234);
//----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    SetIndexEmptyValue(2,0.0);
    SetIndexEmptyValue(3,0.0);
//---- name for DataWindow
    SetIndexLabel(0,"Fractal Up");
    SetIndexLabel(1,"Fractal Down");
//---- initialization done   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
  
  //---- the last calculated bar will be recalculated   
   if(counted_bars > 0) 
      counted_bars--;
   int limit = Bars - counted_bars;
   for(int i = limit; i>0; i--)
   
   {//-Draw the up fractal itself
       ExtUpFractalsBuffer[i]=iFractals(NULL,0,MODE_UPPER,i);
     //-If it is available, put in the array of fractals for higher levels
       if (ExtUpFractalsBuffer[i]!=0)
       HighLevel=iFractals(NULL,0,MODE_UPPER,i);
      if(Close[i]>HighLevel)
       ExtMapBuffer1[i]=(Low[i]-(PipBuffer)*Point);
             
      
      //-Draw the lower fractal itself 
       ExtDownFractalsBuffer[i]=iFractals(NULL,0,MODE_LOWER,i);
     //- if it is available put in the array of lower levels
       if(ExtDownFractalsBuffer[i]!=0)
       LowLevel=iFractals(NULL,0,MODE_LOWER,i);
        if(Close[i]<LowLevel)
       ExtMapBuffer2[i]=(High[i]+(PipBuffer)*Point);
       }
             
   return(0);
   }   
//+------------------------------------------------------------------+